Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:34:07 2011
FILE NAME: historyfileio.f90
PROGRAM NAME: historyfileio
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   232  vec  (   3): Unvectorized loop.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:34:07 2011
FILE NAME: historyfileio.f90
PROGRAM NAME: historyfileio
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != Module HistoryFileIO
     2  !
     3  ! Authors::   SUGIYAMA Ko-ichiro
     4  ! Version::   $Id: historyfileio.f90,v 1.7 2011-07-15 08:43:28 sugiyama Exp $
     5  ! Tag Name::  $Name: arare5-20111010 $
     6  ! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
     7  ! License::   See COPYRIGHT[link:../../COPYRIGHT]
     8  !
     9  !== Overview
    10  !
    11  !ե. Ĺ֥ƥåפͤ.
    12  !
    13  !== Error Handling
    14  !
    15  !== Known Bugs
    16  !
    17  !== Note
    18  !
    19  !== Future Plans
    20  !
    21  
    22  module HistoryFileIO
    23    !
    24    !ե. Ĺ֥ƥåפͤ.
    25    !
    26  
    27    ! ̷ѥ᥿
    28    ! Kind type parameter
    29    !
    30    use gtool_historyauto, only: HistoryAutoCreate, HistoryAutoClose, &
    31      & HistoryAutoAddAttr, HistoryAutoAddWeight, HistoryAutoPutAxis, &
    32      & HistoryAutoAddVariable
    33  
    34    ! ե
    35    ! File I/O support
    36    !
    37    use dc_iounit, only: FileOpen
    38  
    39    ! ̷ѥ᥿
    40    ! Kind type parameter
    41    !
    42    use dc_types, only: DP, &      ! ټ¿. Double precision.
    43      &                 STRING, &  ! ʸ.       Strings.
    44      &                 TOKEN,  &  ! .   Keywords.
    45      &                 STDOUT     ! ɸϤֹ. Unit number of standard output
    46    use mpi_wrapper, only: FLAG_LIB_MPI
    47    use namelist_util, only: namelist_filename
    48  
    49    use axesset,  only: x_X, y_Y, z_Z
    50    use gridset,  only: nx, ny, nz, ncmax
    51    use fileset,  only: filetitle,        &!ǡɽ
    52      &                 filesource,       &!ǡ
    53      &                 FileInstitution    !ǽѹԡȿ
    54    use timeset,  only: Restarttime, EndTime
    55    use composition, only: SpcWetSymbol
    56  
    57    !ۤηػ
    58    implicit none
    59  
    60    !°λ
    61    private
    62  
    63    !³
    64    public HistoryFileIO_init
    65    public HistoryFileIO_finalize
    66  
    67    ! ѿ
    68    ! Private variables
    69    !
    70    character(STRING), parameter:: module_name = 'historyfileio'
    71                                ! ⥸塼̾.
    72                                ! Module name
    73    character(STRING), parameter:: version = &
    74      & '$Name: arare5-20111010 $' // &
    75      & '$Id: historyfileio.f90,v 1.7 2011-07-15 08:43:28 sugiyama Exp $'
    76                                ! ⥸塼ΥС
    77                                ! Module version
    78  
    79  contains
    80  
    81  !!!------------------------------------------------------------------------
    82    subroutine HistoryFileIO_init
    83      !
    84      ! history_file_io ⥸塼νԤޤ.
    85      !--
    86      ! NAMELIST#history_file_io_nml ɤ߹ߤϤμ³ǹԤޤ.
    87      !++
    88      !
    89      ! "history_file_io" module is initialized.
    90      !--
    91      ! "NAMELIST#history_file_io_nml" is loaded in this procedure.
    92      !++
    93      !
    94  
    95      ! ⥸塼 ; USE statements
    96      !
    97  
    98      ! gtool5 netCDF ǡϥ󥿡ե (絬ϥǥ)
    99      ! Interface of Input/Output of gtool5 netCDF data (For large models)
   100      !
   101  
   102      ! ʸ ; Declaration statements
   103      !
   104      implicit none
   105  
   106      !ѿ
   107      real(DP), parameter       :: TimeDisp = 1.0e5 !ϴֳ֤Υǥե
   108      integer :: l
   109  
   110      !-----------------------------------------------------------
   111      ! ҥȥ꡼
   112      !-----------------------------------------------------------
   113      call HistoryAutoCreate(                             &
   114        & title = FileTitle,                              &
   115        & source = FileSource,                            &
   116        & institution = FileInstitution,                  &
   117        & dims=(/'x','y','z','t'/),                       &
   118        & dimsizes=(/nx, ny, nz, 0/),                     &
   119        & longnames=(/'x-coordinate',                     &
   120        &             'y-coordinate',                     &
   121        &             'z-coordinate',                     &
   122        &             'time        '/),                   &
   123        & units=(/'m  ','m  ','m  ','sec'/),              &
   124        & xtypes=(/'float ','float ','float ','double'/), &
   125        & origin   = Restarttime,                         &
   126        & terminus = EndTime,                             &
   127        & interval = TimeDisp,                            &
   128        & flag_mpi_split = FLAG_LIB_MPI,                  &
   129        & namelist_filename = namelist_filename)
   130  
   131      call HistoryAutoAddAttr( &
   132        & varname = 'x', attrname = 'standard_name', &   ! (in)
   133        & value = 'x-coordinate' )                       ! (in)
   134      call HistoryAutoAddAttr( &
   135        & varname = 'y', attrname = 'standard_name', &   ! (in)
   136        & value = 'y-coordinate' )                       ! (in)
   137      call HistoryAutoAddAttr( &
   138        & varname = 'z', attrname = 'standard_name', &   ! (in)
   139        & value = 'z-coordinate' )                       ! (in)
   140  
   141      call HistoryAutoPutAxis('x', x_X(1:nx))
   142      call HistoryAutoPutAxis('y', y_Y(1:ny))
   143      call HistoryAutoPutAxis('z', z_Z(1:nz))
   144  
   145      !  ; Print
   146      !
   147  !    call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   148  !    call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   149  
   150  
   151      !̵Ϥξ
   152      call HistoryAutoAddVariable(  &
   153        & varname='Exner',      &
   154        & dims=(/'x','y','z','t'/), &
   155        & longname='disturbunce of nondimensional pressure', &
   156        & units=' ',            &
   157        & xtype='float' )
   158  
   159      !̵
   160      call HistoryAutoAddVariable(  &
   161        & varname='ExnerAll',      &
   162        & dims=(/'x','y','z','t'/), &
   163        & longname='nondimensional pressure', &
   164        & units=' ',            &
   165        & xtype='float' )
   166  
   167      !̤ξ
   168      call HistoryAutoAddVariable(  &
   169        & varname='PTemp',    &
   170        & dims=(/'x','y','z','t'/), &
   171        & longname='disturbunce of potential temperature',  &
   172        & units='K',            &
   173        & xtype='float' )
   174  
   175      !̤ξ
   176      call HistoryAutoAddVariable(  &
   177        & varname='PTempAll',    &
   178        & dims=(/'x','y','z','t'/), &
   179        & longname='potential temperature',  &
   180        & units='K',            &
   181        & xtype='float' )
   182  
   183      !ʿ®
   184      call HistoryAutoAddVariable(  &
   185        & varname='VelX',       &
   186        & dims=(/'x','y','z','t'/), &
   187        & longname='zonal velocity', &
   188        & units='m.s-1',      &
   189        & xtype='float' )
   190  
   191      !ʿ®
   192      call HistoryAutoAddVariable(  &
   193        & varname='VelY',       &
   194        & dims=(/'x','y','z','t'/), &
   195        & longname='zonal velocity', &
   196        & units='m.s-1',      &
   197        & xtype='float' )
   198  
   199      !ľ®
   200      call HistoryAutoAddVariable(  &
   201        & varname='VelZ',       &
   202        & dims=(/'x','y','z','t'/), &
   203        & longname='vertical velocity', &
   204        & units='m.s-1',      &
   205        & xtype='float' )
   206  
   207      !Ǵ(ư)
   208      call HistoryAutoAddVariable(  &
   209        & varname='Km',         &
   210        & dims=(/'x','y','z','t'/), &
   211        & longname='turbulet diffusion coefficient', &
   212        & units='m2.s-1',            &
   213        & xtype='float' )
   214  
   215      !Ǵ(Ǯ)
   216      call HistoryAutoAddVariable(  &
   217        & varname='Kh',         &
   218        & dims=(/'x','y','z','t'/), &
   219        & longname='turbulet diffusion coefficient for heat', &
   220        & units='m2.s-1',            &
   221        & xtype='float')
   222  
   223      !Ǵ(Ǯ)
   224      call HistoryAutoAddVariable(  &
   225        & varname='CDens',          &
   226        & dims=(/'x','y','z','t'/), &
   227        & longname='Cloud density', &
   228        & units='kg.m-3',           &
   229        & xtype='float')
   230  
   231      !
   232      do l = 1, ncmax
   233        call HistoryAutoAddVariable(                         &
   234          & varname=trim(SpcWetSymbol(l)),                   &
   235          & dims=(/'x','y','z','t'/),                        &
   236          & longname=trim(SpcWetSymbol(l))//' Mixing Ratio', &
   237          & units='kg.kg-1',                                 &
   238          & xtype='float')
   239  
   240        call HistoryAutoAddVariable(                         &
   241          & varname=trim(SpcWetSymbol(l))//'All',            &
   242          & dims=(/'x','y','z','t'/),                        &
   243          & longname=trim(SpcWetSymbol(l))//' Mixing Ratio', &
   244          & units='kg.kg-1',                                 &
   245          & xtype='float')
   246      end do
   247  
   248    end subroutine HistoryFileIO_init
   249  
   250  
   251    subroutine HistoryFileIO_finalize
   252      !
   253      ! ҥȥǡեϤνλԤޤ.
   254      !
   255      ! Terminate history data files output.
   256  
   257      ! ⥸塼 ; USE statements
   258      !
   259  
   260      ! ʸ ; Declaration statements
   261      !
   262      implicit none
   263  
   264      ! ѿ
   265      ! Work variables
   266      !
   267  
   268      ! ¹ʸ ; Executable statement
   269      !
   270  
   271      call HistoryAutoClose
   272  
   273    end subroutine HistoryFileIO_finalize
   274  
   275  end module HistoryFileIO
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:34:07 2011
FILE NAME: historyfileio.f90
PROGRAM NAME: historyfileio
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != Module HistoryFileIO
     2:            !
     3:            ! Authors::   SUGIYAMA Ko-ichiro
     4:            ! Version::   $Id: historyfileio.f90,v 1.7 2011-07-15 08:43:28 sugiyama Exp $ 
     5:            ! Tag Name::  $Name: arare5-20111010 $
     6:            ! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
     7:            ! License::   See COPYRIGHT[link:../../COPYRIGHT]
     8:            !
     9:            !== Overview 
    10:            !
    11:            !ե. Ĺ֥ƥåפͤ.
    12:            !
    13:            !== Error Handling
    14:            !
    15:            !== Known Bugs
    16:            !
    17:            !== Note
    18:            !
    19:            !== Future Plans
    20:            !
    21:            
    22:            module HistoryFileIO
    23:              !
    24:              !ե. Ĺ֥ƥåפͤ.
    25:              !
    26:            
    27:              ! ̷ѥ᥿
    28:              ! Kind type parameter
    29:              !
    30:              use gtool_historyauto, only: HistoryAutoCreate, HistoryAutoClose, &
    31:                & HistoryAutoAddAttr, HistoryAutoAddWeight, HistoryAutoPutAxis, &
    32:                & HistoryAutoAddVariable
    33:            
    34:              ! ե
    35:              ! File I/O support
    36:              !
    37:              use dc_iounit, only: FileOpen
    38:              
    39:              ! ̷ѥ᥿
    40:              ! Kind type parameter
    41:              !
    42:              use dc_types, only: DP, &      ! ټ¿. Double precision. 
    43:                &                 STRING, &  ! ʸ.       Strings. 
    44:                &                 TOKEN,  &  ! .   Keywords. 
    45:                &                 STDOUT     ! ɸϤֹ. Unit number of standard output
    46:              use mpi_wrapper, only: FLAG_LIB_MPI
    47:              use namelist_util, only: namelist_filename
    48:            
    49:              use axesset,  only: x_X, y_Y, z_Z
    50:              use gridset,  only: nx, ny, nz, ncmax
    51:              use fileset,  only: filetitle,        &!ǡɽ
    52:                &                 filesource,       &!ǡ
    53:                &                 FileInstitution    !ǽѹԡȿ
    54:              use timeset,  only: Restarttime, EndTime
    55:              use composition, only: SpcWetSymbol
    56:            
    57:              !ۤηػ
    58:              implicit none
    59:              
    60:              !°λ
    61:              private
    62:            
    63:              !³
    64:              public HistoryFileIO_init
    65:              public HistoryFileIO_finalize
    66:            
    67:              ! ѿ
    68:              ! Private variables
    69:              !
    70:              character(STRING), parameter:: module_name = 'historyfileio'
    71:                                          ! ⥸塼̾. 
    72:                                          ! Module name
    73:              character(STRING), parameter:: version = &
    74:                & '$Name: arare5-20111010 $' // &
    75:                & '$Id: historyfileio.f90,v 1.7 2011-07-15 08:43:28 sugiyama Exp $'
    76:                                          ! ⥸塼ΥС
    77:                                          ! Module version
    78:            
    79:            contains 
    80:            
    81:            !!!------------------------------------------------------------------------
    82:              subroutine HistoryFileIO_init
    83:                !
    84:                ! history_file_io ⥸塼νԤޤ. 
    85:                !--
    86:                ! NAMELIST#history_file_io_nml ɤ߹ߤϤμ³ǹԤޤ. 
    87:                !++
    88:                !
    89:                ! "history_file_io" module is initialized. 
    90:                !--
    91:                ! "NAMELIST#history_file_io_nml" is loaded in this procedure. 
    92:                !++
    93:                !
    94:            
    95:                ! ⥸塼 ; USE statements
    96:                !
    97:            
    98:                ! gtool5 netCDF ǡϥ󥿡ե (絬ϥǥ)
    99:                ! Interface of Input/Output of gtool5 netCDF data (For large models)
   100:                !
   101:            
   102:                ! ʸ ; Declaration statements
   103:                !
   104:                implicit none
   105:                
   106:                !ѿ
   107:                real(DP), parameter       :: TimeDisp = 1.0e5 !ϴֳ֤Υǥե
   108:                integer :: l
   109:            
   110:                !-----------------------------------------------------------
   111:                ! ҥȥ꡼
   112:                !-----------------------------------------------------------
   113:                call HistoryAutoCreate(                             &
   114:                  & title = FileTitle,                              &
   115:                  & source = FileSource,                            &
   116:                  & institution = FileInstitution,                  &
   117:                  & dims=(/'x','y','z','t'/),                       &
   118:                  & dimsizes=(/nx, ny, nz, 0/),                     &
   119:                  & longnames=(/'x-coordinate',                     &
   120:                  &             'y-coordinate',                     &
   121:                  &             'z-coordinate',                     &
   122:                  &             'time        '/),                   &
   123:                  & units=(/'m  ','m  ','m  ','sec'/),              &
   124:                  & xtypes=(/'float ','float ','float ','double'/), &
   125:                  & origin   = Restarttime,                         & 
   126:                  & terminus = EndTime,                             &
   127:                  & interval = TimeDisp,                            &       
   128:                  & flag_mpi_split = FLAG_LIB_MPI,                  &
   129:                  & namelist_filename = namelist_filename)  
   130:            
   131:                call HistoryAutoAddAttr( &
   132:                  & varname = 'x', attrname = 'standard_name', &   ! (in)
   133:                  & value = 'x-coordinate' )                       ! (in)
   134:                call HistoryAutoAddAttr( &
   135:                  & varname = 'y', attrname = 'standard_name', &   ! (in)
   136:                  & value = 'y-coordinate' )                       ! (in)
   137:                call HistoryAutoAddAttr( &
   138:                  & varname = 'z', attrname = 'standard_name', &   ! (in)
   139:                  & value = 'z-coordinate' )                       ! (in)
   140:                
   141:                call HistoryAutoPutAxis('x', x_X(1:nx))
   142:                call HistoryAutoPutAxis('y', y_Y(1:ny))
   143:                call HistoryAutoPutAxis('z', z_Z(1:nz))
   144:            
   145:                !  ; Print
   146:                !
   147:            !    call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   148:            !    call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   149:            
   150:            
   151:                !̵Ϥξ
   152:                call HistoryAutoAddVariable(  &
   153:                  & varname='Exner',      &  
   154:                  & dims=(/'x','y','z','t'/), &
   155:                  & longname='disturbunce of nondimensional pressure', &
   156:                  & units=' ',            &        
   157:                  & xtype='float' )
   158:            
   159:                !̵
   160:                call HistoryAutoAddVariable(  &
   161:                  & varname='ExnerAll',      &  
   162:                  & dims=(/'x','y','z','t'/), &
   163:                  & longname='nondimensional pressure', &
   164:                  & units=' ',            &        
   165:                  & xtype='float' )
   166:                
   167:                !̤ξ
   168:                call HistoryAutoAddVariable(  &
   169:                  & varname='PTemp',    &
   170:                  & dims=(/'x','y','z','t'/), &
   171:                  & longname='disturbunce of potential temperature',  &
   172:                  & units='K',            &
   173:                  & xtype='float' )
   174:            
   175:                !̤ξ
   176:                call HistoryAutoAddVariable(  &
   177:                  & varname='PTempAll',    &
   178:                  & dims=(/'x','y','z','t'/), &
   179:                  & longname='potential temperature',  &
   180:                  & units='K',            &
   181:                  & xtype='float' )
   182:            
   183:                !ʿ®
   184:                call HistoryAutoAddVariable(  &
   185:                  & varname='VelX',       &
   186:                  & dims=(/'x','y','z','t'/), &
   187:                  & longname='zonal velocity', &
   188:                  & units='m.s-1',      &
   189:                  & xtype='float' )
   190:            
   191:                !ʿ®
   192:                call HistoryAutoAddVariable(  &
   193:                  & varname='VelY',       &
   194:                  & dims=(/'x','y','z','t'/), &
   195:                  & longname='zonal velocity', &
   196:                  & units='m.s-1',      &
   197:                  & xtype='float' )
   198:            
   199:                !ľ®
   200:                call HistoryAutoAddVariable(  &
   201:                  & varname='VelZ',       &
   202:                  & dims=(/'x','y','z','t'/), &
   203:                  & longname='vertical velocity', &
   204:                  & units='m.s-1',      &
   205:                  & xtype='float' )
   206:            
   207:                !Ǵ(ư)
   208:                call HistoryAutoAddVariable(  &
   209:                  & varname='Km',         &
   210:                  & dims=(/'x','y','z','t'/), &
   211:                  & longname='turbulet diffusion coefficient', &
   212:                  & units='m2.s-1',            &
   213:                  & xtype='float' )
   214:              
   215:                !Ǵ(Ǯ)
   216:                call HistoryAutoAddVariable(  &
   217:                  & varname='Kh',         &
   218:                  & dims=(/'x','y','z','t'/), &
   219:                  & longname='turbulet diffusion coefficient for heat', &
   220:                  & units='m2.s-1',            &
   221:                  & xtype='float')
   222:            
   223:                !Ǵ(Ǯ)
   224:                call HistoryAutoAddVariable(  &
   225:                  & varname='CDens',          &
   226:                  & dims=(/'x','y','z','t'/), &
   227:                  & longname='Cloud density', &
   228:                  & units='kg.m-3',           &
   229:                  & xtype='float')
   230:              
   231:                !
   232: +------>       do l = 1, ncmax
   233: |                call HistoryAutoAddVariable(                         &
   234: |                  & varname=trim(SpcWetSymbol(l)),                   &
   235: |                  & dims=(/'x','y','z','t'/),                        &
   236: |                  & longname=trim(SpcWetSymbol(l))//' Mixing Ratio', &
   237: |                  & units='kg.kg-1',                                 &
   238: |                  & xtype='float')
   239: |          
   240: |                call HistoryAutoAddVariable(                         &
   241: |                  & varname=trim(SpcWetSymbol(l))//'All',            &
   242: |                  & dims=(/'x','y','z','t'/),                        &
   243: |                  & longname=trim(SpcWetSymbol(l))//' Mixing Ratio', &
   244: |                  & units='kg.kg-1',                                 &
   245: |                  & xtype='float')
   246: +------        end do
   247:                
   248:              end subroutine HistoryFileIO_init
   249:            
   250:            
   251:              subroutine HistoryFileIO_finalize
   252:                !
   253:                ! ҥȥǡեϤνλԤޤ. 
   254:                !
   255:                ! Terminate history data files output. 
   256:            
   257:                ! ⥸塼 ; USE statements
   258:                !
   259:            
   260:                ! ʸ ; Declaration statements
   261:                !
   262:                implicit none
   263:            
   264:                ! ѿ
   265:                ! Work variables
   266:                !
   267:            
   268:                ! ¹ʸ ; Executable statement
   269:                !
   270:            
   271:                call HistoryAutoClose
   272:            
   273:              end subroutine HistoryFileIO_finalize
   274:              
   275:            end module HistoryFileIO
