Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:35:18 2011
FILE NAME: cloudphys_marscond.f90
PROGRAM NAME: cloudphys_marscond
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   191  opt  (  11): Fused array assignments. :line 191 - 192
   191  vec  (   4): Vectorized array expression.
   191  vec  (   4): Vectorized array expression.
   209  opt  (  11): Fused array assignments. :line 209 - 225
   209  vec  (   4): Vectorized array expression.
   235  vec  (   1): Vectorized loop.
   260  opt  (  11): Fused array assignments. :line 260 - 272
   260  vec  (   4): Vectorized array expression.
   280  opt  (  11): Fused array assignments. :line 280 - 281
   280  vec  (   4): Vectorized array expression.
   280  vec  (   4): Vectorized array expression.
   289  opt  (  11): Fused array assignments. :line 289 - 295
   289  vec  (   4): Vectorized array expression.
   289  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:35:18 2011
FILE NAME: cloudphys_marscond.f90
PROGRAM NAME: cloudphys_marscond
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  !---------------------------------------------------------------------
     2  !     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
     3  !---------------------------------------------------------------------
     4  != Module CloudPhys_marscond
     5  !
     6  !   * Developer: KITAMORI Taichi, YAMASHITA Tatsuya, SUGIYAMA Ko-ichiro
     7  !   * Version: $
     8  !   * Tag Name: $Name: arare5-20111010 $
     9  !   * Change History:
    10  !
    11  !== Overview
    12  !
    13  !ŷ/ȯ̤׻.
    14  !
    15  !== Error Handling
    16  !
    17  !== Known Bugs
    18  !
    19  !== Note
    20  !
    21  ! ȻˤäƱγĹˤĹ.
    22  ! ȯ̤¸ߤ̤¿, ȯ̤¸ߤ̤ˤ.
    23  ! ̩٤ȯŸ(ŷʬ)׻.
    24  ! ˾ʤäȤ˾ȯʤʤäƤޤäƤΤ,
    25  ! ʬľ.
    26  
    27  !
    28  !== Future Plans
    29  !
    30  
    31  module Cloudphys_MarsCond
    32  
    33    use dc_types,   only: DP, STRING
    34    use dc_iounit,  only: FileOpen
    35    use dc_message, only: MessageNotify
    36    use gtool_historyauto, only: HistoryAutoAddVariable, HistoryAutoPut
    37  
    38    use mpi_wrapper,only: myrank
    39    use gridset,  only: imin, imax, jmin, jmax, kmin, kmax, &
    40      &                 nx, ny, nz
    41    use basicset, only: xyz_PTempBZ,     & ! ̴ܾ
    42      &                 xyz_ExnerBZ,     & ! ̵
    43      &                 xyz_VelSoundBZ,  &! ®
    44      &                 xyz_VPTempBZ,    &! 
    45      &                 xyz_DensBZ        ! ̩
    46    use constants, only:GasRDry,         & ! 
    47      &                 PressSfc,        & ! ɽ̰
    48      &                 CpDry              ! 갵Ǯ
    49    use SetMargin, only:SetMargin_xyz
    50    use fillnegative, only: FillNegativeDensity
    51    use namelist_util, only: namelist_filename
    52    use timeset, only: TimeN, DelTimeShort
    53    use setmargin,only: SetMargin_xyz, SetMargin_xyzf, SetMargin_pyz, SetMargin_xqz, SetMargin_xyr
    54  
    55    implicit none
    56  
    57    private
    58  
    59    real(DP), save   :: DensIce     = 1.565d3  ! ̩ [kg/m^3]
    60    real(DP), save   :: NumAerosol  = 0.0d0  ! ο̩ [1/kg]
    61    real(DP), save   :: RadiAerosol = 0.0d0  ! ο̩ [1/kg]
    62    real(DP), save   :: Kd          = 0.0d0  ! 絤ǮƳ [W/K m]
    63    real(DP), save   :: SatRatioCr  = 0.0d0  ! ׳˰ []
    64    real(DP), save   :: SatRtWetAdia = 0.0d0 ! Ǯ˰ []
    65    real(DP), save   :: CO2LatHeat  = 0.0d0  ! ñ̼̤ζŷǮ [J/kg]
    66    real(DP), save   :: AntA        = 27.4d0
    67    real(DP), save   :: AntB        = 3103.0d0
    68    real(DP), save   :: Pi          = 3.1415926535897932385d0 ! ߼Ψ
    69    real(DP), save   :: CDensCr     = 5.0d-5
    70  
    71    public cloudphys_marscond_init
    72    public cloudphys_marscond_forcing
    73  
    74  contains
    75  
    76    subroutine cloudphys_marscond_init
    77      !
    78      !NAMELIST ʪɤ߹
    79      !
    80  
    81      integer                       :: unit
    82  
    83      ! NAMELIST
    84      NAMELIST /cloudphys_marscond_nml/ DensIce, NumAerosol, RadiAerosol, Kd, &
    85        & SatRatioCr, SatRtWetAdia, CDensCr
    86  
    87      call FileOpen(unit, file=namelist_filename, mode='r')
    88      read(unit, NML=cloudphys_marscond_nml)
    89      close(unit)
    90  
    91      ! Ǯ. ȸʤ.
    92      !   饦ڥδط dp/dT = L p / (R T^2) 
    93      !   Antoine μ \ln p = A - B/T .
    94      CO2LatHeat = AntB * GasRDry
    95  
    96      if (myrank == 0) then
    97        call MessageNotify( "M", &
    98          & "cloudset_init", "DensIce = %f",  d=(/DensIce/) )
    99        call MessageNotify( "M", &
   100          & "cloudset_init", "NumAerosol = %f",  d=(/NumAerosol/) )
   101        call MessageNotify( "M", &
   102          & "cloudset_init", "RadiAerosol = %f",  d=(/RadiAerosol/) )
   103        call MessageNotify( "M", &
   104          & "cloudset_init", "Kd = %f",  d=(/Kd/) )
   105        call MessageNotify( "M", &
   106          & "cloudset_init", "SatRatioCr = %f",  d=(/SatRatioCr/) )
   107        call MessageNotify( "M", &
   108          & "cloudset_init", "SatRtWetAdia = %f",  d=(/SatRtWetAdia/) )
   109      end if
   110  
   111      call HistoryAutoAddVariable(  &
   112        & varname='PTempCond',&
   113        & dims=(/'x','y','z','t'/),     &
   114        & longname='Latent heat term of potential temperature', &
   115        & units='K.s-1',    &
   116        & xtype='float')
   117  
   118      call HistoryAutoAddVariable(  &
   119        & varname='ExnerCond',&
   120        & dims=(/'x','y','z','t'/),     &
   121        & longname='Latent heat term of exner function', &
   122        & units='s-1',    &
   123        & xtype='float')
   124  
   125      call HistoryAutoAddVariable(  &
   126        & varname='CDensCond',&
   127        & dims=(/'x','y','z','t'/),     &
   128        & longname='Latent heat term of cloud density', &
   129        & units='K.m-3.s-1',    &
   130        & xtype='float')
   131  
   132    end subroutine cloudphys_marscond_init
   133  
   134  
   135  !!!----------------------------------------------------
   136    subroutine cloudphys_marscond_forcing(  &
   137      &  xyz_PTempNs,         &  !(in) 
   138      &  xyz_ExnerNs,         &  !(in) ʡؿ
   139      &  xyz_CDensNs,         &  !(in)
   140      &  xyz_DPTempDtNl,      &  !(in)
   141      &  xyz_DExnerDtNl,      &  !(in)
   142      &  xyz_DCDensDtNl,      &  !(in)
   143      &  xyz_PTempAs,         &  !(out)
   144      &  xyz_CDensAs,         &  !(out) ̩
   145      &  xyz_DExnerDtNs       &  !(out)
   146      & )
   147  
   148      ! ۤηػ
   149      implicit none
   150  
   151      ! Input
   152      real(DP), intent(in)   :: xyz_PTempNs(imin:imax, jmin:jmax, kmin:kmax)
   153                                          ! ̵ [1]
   154      real(DP), intent(in)   :: xyz_ExnerNs(imin:imax, jmin:jmax, kmin:kmax)
   155                                          !
   156      real(DP), intent(in)   :: xyz_CDensNs(imin:imax, jmin:jmax, kmin:kmax)
   157                                          !
   158      real(DP), intent(in)   :: xyz_DPTempDtNl(imin:imax, jmin:jmax, kmin:kmax)
   159  
   160      real(DP), intent(in)   :: xyz_DExnerDtNl(imin:imax, jmin:jmax, kmin:kmax)
   161  
   162      real(DP), intent(in)   :: xyz_DCDensDtNl(imin:imax, jmin:jmax, kmin:kmax)
   163  
   164      real(DP), intent(out)  :: xyz_PTempAs(imin:imax, jmin:jmax, kmin:kmax)
   165                                          !  [K]
   166      real(DP), intent(out)  :: xyz_CDensAs(imin:imax, jmin:jmax, kmin:kmax)
   167                                          ! ̩   [kg/m^3]
   168      real(DP), intent(out)  :: xyz_DExnerDtNs(imin:imax, jmin:jmax, kmin:kmax)
   169                                          ! ŷǮˤ벹ѲΨ [K/s]
   170  
   171      ! Work
   172      real(DP)               :: xyz_RadiCloud(imin:imax, jmin:jmax, kmin:kmax)
   173                                          ! γȾ [m]
   174      real(DP)               :: xyz_SatRatio(imin:imax, jmin:jmax, kmin:kmax)
   175      real(DP)               :: xyz_Rh(imin:imax, jmin:jmax, kmin:kmax)
   176      real(DP)               :: xyz_TempAll(imin:imax, jmin:jmax, kmin:kmax)
   177      real(DP)               :: xyz_Mcond(imin:imax, jmin:jmax, kmin:kmax)
   178      real(DP)               :: xyz_Qcond(imin:imax, jmin:jmax, kmin:kmax)
   179      real(DP)               :: xyz_McondTmp(imin:imax, jmin:jmax, kmin:kmax)
   180      real(DP)               :: xyz_PIcond(imin:imax, jmin:jmax, kmin:kmax)
   181      real(DP)               :: xyz_Zero(imin:imax, jmin:jmax, kmin:kmax)
   182      real(DP)               :: xyz_PTempTmp(imin:imax, jmin:jmax, kmin:kmax)
   183      real(DP)               :: xyz_CDensTmp(imin:imax, jmin:jmax, kmin:kmax)
   184      logical                :: xyz_Mask(imin:imax, jmin:jmax, kmin:kmax)
   185      integer                :: i,j,k        ! 롼ѿ
   186  
   187  
   188  
   189      ! ȯŸ
   190      !
   191      xyz_PTempTmp = xyz_PTempNs + DelTimeShort * xyz_DPTempDtNl
     .        if (jmax + 1 - jmin .gt. 0) then                                  
     .           J1 = and(jmax + 1 - jmin,1)                                    
     .  !CDIR    NODEP                                                          
     .           do t721 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t723 = 1, imax + 1 - imin                                
     .                 xyz_ptemptmp(xyz_ptemptmp.DSC.L1+t723-1,t721-1+          
     .       1            xyz_ptemptmp.DSC.L2,t719+xyz_ptemptmp.DSC.L3) =       
     .       2            xyz_ptempns(t176+t723-1,t721-1+t178,t719+t180) +      
     .       3            deltimeshort*xyz_dptempdtnl(t206+t723-1,t721-1+t208,  
     .       4            t719+t210)                                            
     .                 xyz_cdenstmp(xyz_cdenstmp.DSC.L1+t723-1,t721-1+          
     .       1            xyz_cdenstmp.DSC.L2,t719+xyz_cdenstmp.DSC.L3) =       
     .       2            xyz_cdensns(t196+t723-1,t721-1+t198,t719+t200) +      
     .       3            deltimeshort*xyz_dcdensdtnl(t226+t723-1,t721-1+t228,  
     .       4            t719+t230)                                            
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t721 = J1 + 1, jmax + 1 - jmin, 2                           
     .  !CDIR       NODEP                                                       
     .              do t723 = 1, imax + 1 - imin                                
     .                 xyz_ptemptmp(xyz_ptemptmp.DSC.L1+t723-1,t721-1+          
     .       1            xyz_ptemptmp.DSC.L2,t719+xyz_ptemptmp.DSC.L3) =       
     .       2            xyz_ptempns(t176+t723-1,t721-1+t178,t719+t180) +      
     .       3            deltimeshort*xyz_dptempdtnl(t206+t723-1,t721-1+t208,  
     .       4            t719+t210)                                            
     .                 xyz_ptemptmp(xyz_ptemptmp.DSC.L1+t723-1,t721+            
     .       1            xyz_ptemptmp.DSC.L2,t719+xyz_ptemptmp.DSC.L3) =       
     .       2            xyz_ptempns(t176+t723-1,t721+t178,t719+t180) +        
     .       3            deltimeshort*xyz_dptempdtnl(t206+t723-1,t721+t208,t719
     .       4            +t210)                                                
     .                 xyz_cdenstmp(xyz_cdenstmp.DSC.L1+t723-1,t721-1+          
     .       1            xyz_cdenstmp.DSC.L2,t719+xyz_cdenstmp.DSC.L3) =       
     .       2            xyz_cdensns(t196+t723-1,t721-1+t198,t719+t200) +      
     .       3            deltimeshort*xyz_dcdensdtnl(t226+t723-1,t721-1+t228,  
     .       4            t719+t230)                                            
     .                 xyz_cdenstmp(xyz_cdenstmp.DSC.L1+t723-1,t721+            
     .       1            xyz_cdenstmp.DSC.L2,t719+xyz_cdenstmp.DSC.L3) =       
     .       2            xyz_cdensns(t196+t723-1,t721+t198,t719+t200) +        
     .       3            deltimeshort*xyz_dcdensdtnl(t226+t723-1,t721+t228,t719
     .       4            +t230)                                                
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   192      xyz_CDensTmp = xyz_CDensNs + DelTimeShort * xyz_DCDensDtNl
   193  
   194      ! Set Margin
   195      !
   196      call SetMargin_xyz(xyz_PTempTmp)
   197      call SetMargin_xyz(xyz_CDensTmp)
   198  
   199      ! ήˤʤäʬ
   200      !
   201      call FillNegativeDensity(xyz_CDensTmp)
   202  
   203      ! Set Margin
   204      !
   205      call SetMargin_xyz(xyz_CDensTmp)
   206  
   207      ! tendency  Ns ͤǷ׻
   208      !
   209      xyz_TempAll = (xyz_ExnerBZ + xyz_ExnerNs) * (xyz_PTempBZ + xyz_PTempNs)
     .  !CDIR NODEP                                                             
     .        do t747 = 1, t477                                                 
     .           xyz_tempall(xyz_tempall.DSC.L1+t747-1,t745+xyz_tempall.DSC.L2, 
     .       1      t743+xyz_tempall.DSC.L3) = (xyz_exnerbz(t45+t747-1,t745+t47,
     .       2      t743+t49)+xyz_exnerns(t186+t747-1,t745+t188,t743+t190))*(   
     .       3      xyz_ptempbz(xyz_ptempbz.DSC.L1+t747-1,t745+                 
     .       4      xyz_ptempbz.DSC.L2,t743+xyz_ptempbz.DSC.L3)+xyz_ptempns(t176
     .       5      +t747-1,t745+t178,t743+t180))                               
     .           xyz_mask(xyz_mask.DSC.L1+t747-1,t745+xyz_mask.DSC.L2,t743+     
     .       1      xyz_mask.DSC.L3) = 0                                        
     .           xyz_zero(xyz_zero.DSC.L1+t747-1,t745+xyz_zero.DSC.L2,t743+     
     .       1      xyz_zero.DSC.L3) = 0.0000000000000000e+000                  
     .           xyz_rh(xyz_rh.DSC.L1+t747-1,t745+xyz_rh.DSC.L2,t743+           
     .       1      xyz_rh.DSC.L3) = co2latheat**2.00000000000000e+000/(kd*     
     .       2      gasrdry*xyz_tempall(xyz_tempall.DSC.L1+t747-1,t745+         
     .       3      xyz_tempall.DSC.L2,t743+xyz_tempall.DSC.L3)**               
     .       4      2.00000000000000e+000)                                      
     .           xyz_satratio(xyz_satratio.DSC.L1+t747-1,t745+                  
     .       1      xyz_satratio.DSC.L2,t743+xyz_satratio.DSC.L3) = presssfc*(  
     .       2      xyz_exnerbz(t45+t747-1,t745+t47,t743+t49)+xyz_exnerns(t186+ 
     .       3      t747-1,t745+t188,t743+t190))**(cpdry/gasrdry)/dexp(anta -   
     .       4      antb/xyz_tempall(xyz_tempall.DSC.L1+t747-1,t745+            
     .       5      xyz_tempall.DSC.L2,t743+xyz_tempall.DSC.L3))                
     .           xyz_radicloud(xyz_radicloud.DSC.L1+t747-1,t745+                
     .       1      xyz_radicloud.DSC.L2,t743+xyz_radicloud.DSC.L3) = (         
     .       2      radiaerosol**3.00000000000000e+000 + 3.00000000000000e+000* 
     .       3      xyz_cdensns(t196+t747-1,t745+t198,t743+t200)/(              
     .       4      4.00000000000000e+000*pi*densice*xyz_densbz(t23+t747-1,t745+
     .       5      t25,t743+t27)*numaerosol))**3.33333333333333e-001           
     .        end do                                                            
   210      xyz_Mask = .false.
   211      xyz_Zero = 0.0d0
   212  
   213      ! Ǯ͢˴ؤ뷸
   214      !
   215      xyz_Rh = (CO2LatHeat**2.0d0) / (Kd * GasRDry * (xyz_TempAll**2.0d0))
   216  
   217      ! ˰ (1.36) .
   218      !
   219      xyz_SatRatio =  &
   220        &  PressSfc * (xyz_ExnerBZ + xyz_ExnerNs)**(CpDry / GasRDry) &
   221        &  / exp( AntA - AntB / xyz_TempAll )
   222  
   223      ! γȾ.
   224      !
   225      xyz_RadiCloud =   &
   226        & (  &
   227        &     RadiAerosol**3.0d0  &
   228        &   + 3.0d0 * xyz_CDensNs / (4.0d0 * Pi * DensIce * xyz_DensBZ * NumAerosol) &
   229        &  ) ** (1.0d0 / 3.0d0)
   230  
   231      ! ŷ̤η׻
   232      !
   233      do k = kmin, kmax
   234        do j = jmin, jmax
   235          do i = imin, imax
   236            if (xyz_SatRatio(i,j,k) - SatRatioCr > epsilon(0.0d0)) then
   237              ! ˰椬᤿׳˰礭
   238              ! CO2 ˰μϵ絤Ѥ˰μʤΤʤΤǧɬפ.
   239              !
   240              xyz_Mask(i,j,k) = .true.
   241  
   242            else if (xyz_CDensNs(i,j,k) > CDensCr ) then
   243              ! ׳˰ĶƤʤ, ̩٤ͰʾǤ
   244              ! ˰椬 1 ʾΤȤ˶ŷ, 1 ʲΤȤ˾ȯ.
   245              !
   246              xyz_Mask(i,j,k) = .true.
   247  
   248            else if (xyz_CDensNs(i,j,k) /= 0.0d0 .and. xyz_SatRatio(i,j,k) < 1.0d0 ) then
   249              ! ̩٤̤, ˰ 1.0 ̤Ǥ˾ȯ.
   250              !
   251              xyz_Mask(i,j,k) = .true.
   252  
   253            end if
   254          end do
     .  !CDIR NODEP                                                             
     .        do i = 1, imax + 1 - imin                                         
     .           if (xyz_satratio(imin+i-1,j,k) - satratiocr .gt.               
     .       1      2.22044604925031e-016) then                                 
     .              xyz_mask(imin+i-1,j,k) = 1                                  
     .           else                                                           
     .              if (xyz_cdensns(imin+i-1,j,k) .gt. cdenscr) then            
     .                 xyz_mask(imin+i-1,j,k) = 1                               
     .              else                                                        
     .                 if (xyz_cdensns(imin+i-1,j,k).ne.0.0000000000000000e+000 
     .       1             .and. xyz_satratio(imin+i-1,j,k).lt.                 
     .       2            1.00000000000000e+000) then                           
     .                    xyz_mask(imin+i-1,j,k) = 1                            
     .                 endif                                                    
     .              endif                                                       
     .           endif                                                          
     .        end do                                                            
   255        end do
   256      end do
   257  
   258      ! ŷ̤βͤ׻.
   259      !
   260      xyz_McondTmp =                                                &
     .        D1 = 1.D0/deltimeshort                                            
     .  !CDIR NODEP                                                             
     .        do t801 = 1, xyz_cdenstmp.DSC.U1 + 1 - xyz_cdenstmp.DSC.L1        
     .           xyz_mcondtmp(xyz_mcondtmp.DSC.L1+t801-1,t799+                  
     .       1      xyz_mcondtmp.DSC.L2,t797+xyz_mcondtmp.DSC.L3) = max((-      
     .       2      xyz_cdenstmp(xyz_cdenstmp.DSC.L1+t801-1,t799+               
     .       3      xyz_cdenstmp.DSC.L2,t797+xyz_cdenstmp.DSC.L3)*D1),          
     .       4      4.00000000000000e+000*pi*xyz_radicloud(xyz_radicloud.DSC.L1+
     .       5      t801-1,t799+xyz_radicloud.DSC.L2,t797+xyz_radicloud.DSC.L3)*
     .       6      xyz_densbz(t23+t801-1,t799+t25,t797+t27)*numaerosol/xyz_rh( 
     .       7      xyz_rh.DSC.L1+t801-1,t799+xyz_rh.DSC.L2,t797+xyz_rh.DSC.L3)*
     .       8      (xyz_satratio(xyz_satratio.DSC.L1+t801-1,t799+              
     .       9      xyz_satratio.DSC.L2,t797+xyz_satratio.DSC.L3)-              
     .       .      1.00000000000000e+000))                                     
     .           t618 = cvmgt(xyz_mcondtmp(xyz_mcondtmp.DSC.L1+t801-1,t799+     
     .       1      xyz_mcondtmp.DSC.L2,t797+xyz_mcondtmp.DSC.L3),xyz_zero(     
     .       2      xyz_zero.DSC.L1+t801-1,t799+xyz_zero.DSC.L2,t797+           
     .       3      xyz_zero.DSC.L3),xyz_mask(xyz_mask.DSC.L1+t801-1,t799+      
     .       4      xyz_mask.DSC.L2,t797+xyz_mask.DSC.L3))                      
     .           xyz_mcond(xyz_mcond.DSC.L1+t801-1,t799+xyz_mcond.DSC.L2,t797+  
     .       1      xyz_mcond.DSC.L3) = t618                                    
     .           xyz_cdensas(t246+t801-1,t799+t248,t797+t250) = xyz_cdenstmp(   
     .       1      xyz_cdenstmp.DSC.L1+t801-1,t799+xyz_cdenstmp.DSC.L2,t797+   
     .       2      xyz_cdenstmp.DSC.L3) + deltimeshort*xyz_mcond(              
     .       3      xyz_mcond.DSC.L1+t801-1,t799+xyz_mcond.DSC.L2,t797+         
     .       4      xyz_mcond.DSC.L3)                                           
     .        end do                                                            
   261        & max( - xyz_CDensTmp / DelTimeShort,                       &
   262        &      4.0d0 * Pi * xyz_RadiCloud * xyz_DensBZ * NumAerosol &
   263        &        / xyz_Rh * (xyz_SatRatio - 1.0d0)                  &
   264        &   )
   265  
   266      ! ŷ̤׻. Mask  .false. Ǥˤϥ
   267      !
   268      xyz_Mcond = merge(xyz_McondTmp, xyz_Zero, xyz_Mask)
   269  
   270      ! ̩٤η׻
   271      !
   272      xyz_CDensAs = xyz_CDensTmp + DelTimeShort * xyz_Mcond
   273  
   274      ! Set Margin
   275      !
   276      call SetMargin_xyz(xyz_CDensAs)
   277  
   278      ! Ѳη׻
   279      !
   280      xyz_Qcond = CO2LatHeat * xyz_Mcond / (CpDry * xyz_DensBZ * xyz_ExnerBZ)
     .        if (xyz_mcond.DSC.U2 + 1 - xyz_mcond.DSC.L2 .gt. 0) then          
     .           J2 = and(xyz_mcond.DSC.U2 + 1 - xyz_mcond.DSC.L2,1)            
     .  !CDIR    NODEP                                                          
     .           do t844 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t846 = 1, xyz_mcond.DSC.U1 + 1 - xyz_mcond.DSC.L1        
     .                 xyz_qcond(xyz_qcond.DSC.L1+t846-1,t844-1+xyz_qcond.DSC.L2
     .       1            ,t842+xyz_qcond.DSC.L3) = co2latheat*xyz_mcond(       
     .       2            xyz_mcond.DSC.L1+t846-1,t844-1+xyz_mcond.DSC.L2,t842+ 
     .       3            xyz_mcond.DSC.L3)/(cpdry*xyz_densbz(t23+t846-1,t844-1+
     .       4            t25,t842+t27)*xyz_exnerbz(t45+t846-1,t844-1+t47,t842+ 
     .       5            t49))                                                 
     .                 xyz_ptempas(t236+t846-1,t844-1+t238,t842+t240) =         
     .       1            xyz_ptemptmp(xyz_ptemptmp.DSC.L1+t846-1,t844-1+       
     .       2            xyz_ptemptmp.DSC.L2,t842+xyz_ptemptmp.DSC.L3) +       
     .       3            deltimeshort*xyz_qcond(xyz_qcond.DSC.L1+t846-1,t844-1+
     .       4            xyz_qcond.DSC.L2,t842+xyz_qcond.DSC.L3)               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t844 = J2 + 1, xyz_mcond.DSC.U2 + 1 - xyz_mcond.DSC.L2, 2   
     .  !CDIR       NODEP                                                       
     .              do t846 = 1, xyz_mcond.DSC.U1 + 1 - xyz_mcond.DSC.L1        
     .                 xyz_qcond(xyz_qcond.DSC.L1+t846-1,t844-1+xyz_qcond.DSC.L2
     .       1            ,t842+xyz_qcond.DSC.L3) = co2latheat*xyz_mcond(       
     .       2            xyz_mcond.DSC.L1+t846-1,t844-1+xyz_mcond.DSC.L2,t842+ 
     .       3            xyz_mcond.DSC.L3)/(cpdry*xyz_densbz(t23+t846-1,t844-1+
     .       4            t25,t842+t27)*xyz_exnerbz(t45+t846-1,t844-1+t47,t842+ 
     .       5            t49))                                                 
     .                 xyz_qcond(xyz_qcond.DSC.L1+t846-1,t844+xyz_qcond.DSC.L2, 
     .       1            t842+xyz_qcond.DSC.L3) = co2latheat*xyz_mcond(        
     .       2            xyz_mcond.DSC.L1+t846-1,t844+xyz_mcond.DSC.L2,t842+   
     .       3            xyz_mcond.DSC.L3)/(cpdry*xyz_densbz(t23+t846-1,t844+  
     .       4            t25,t842+t27)*xyz_exnerbz(t45+t846-1,t844+t47,t842+t49
     .       5            ))                                                    
     .                 xyz_ptempas(t236+t846-1,t844-1+t238,t842+t240) =         
     .       1            xyz_ptemptmp(xyz_ptemptmp.DSC.L1+t846-1,t844-1+       
     .       2            xyz_ptemptmp.DSC.L2,t842+xyz_ptemptmp.DSC.L3) +       
     .       3            deltimeshort*xyz_qcond(xyz_qcond.DSC.L1+t846-1,t844-1+
     .       4            xyz_qcond.DSC.L2,t842+xyz_qcond.DSC.L3)               
     .                 xyz_ptempas(t236+t846-1,t844+t238,t842+t240) =           
     .       1            xyz_ptemptmp(xyz_ptemptmp.DSC.L1+t846-1,t844+         
     .       2            xyz_ptemptmp.DSC.L2,t842+xyz_ptemptmp.DSC.L3) +       
     .       3            deltimeshort*xyz_qcond(xyz_qcond.DSC.L1+t846-1,t844+  
     .       4            xyz_qcond.DSC.L2,t842+xyz_qcond.DSC.L3)               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   281      xyz_PTempAs = xyz_PTempTmp + DelTimeShort * xyz_QCond
   282  
   283      ! Set Margin
   284      !
   285      call SetMargin_xyz(xyz_PTempAs)
   286  
   287      ! ʡؿλʬ
   288      !
   289      xyz_PIcond =                                                   &
     .        if (xyz_velsoundbz.DSC.U2 - xyz_velsoundbz.DSC.L2 + 1 .gt. 0) then
     .           J3 = and(xyz_velsoundbz.DSC.U2 - xyz_velsoundbz.DSC.L2 + 1,1)  
     .  !CDIR    NODEP                                                          
     .           do t871 = 1, J3                                                
     .  !CDIR       NODEP                                                       
     .              do t873=1,xyz_velsoundbz.DSC.U1-xyz_velsoundbz.DSC.L1+1     
     .                 xyz_picond(xyz_picond.DSC.L1+t873-1,t871-1+              
     .       1            xyz_picond.DSC.L2,t869+xyz_picond.DSC.L3) =           
     .       2            xyz_velsoundbz(xyz_velsoundbz.DSC.L1+t873-1,t871-1+   
     .       3            xyz_velsoundbz.DSC.L2,t869+xyz_velsoundbz.DSC.L3)**   
     .       4            2.00000000000000e+000/(cpdry*xyz_densbz(t23+t873-1,   
     .       5            t871-1+t25,t869+t27)*xyz_vptempbz(xyz_vptempbz.DSC.L1+
     .       6            t873-1,t871-1+xyz_vptempbz.DSC.L2,t869+               
     .       7            xyz_vptempbz.DSC.L3)**2.00000000000000e+000)*xyz_mcond
     .       8            (xyz_mcond.DSC.L1+t873-1,t871-1+xyz_mcond.DSC.L2,t869+
     .       9            xyz_mcond.DSC.L3)*(co2latheat/(cpdry*xyz_exnerbz(t45+ 
     .       .            t873-1,t871-1+t47,t869+t49))-xyz_vptempbz(            
     .       1            xyz_vptempbz.DSC.L1+t873-1,t871-1+xyz_vptempbz.DSC.L2,
     .       2            t869+xyz_vptempbz.DSC.L3))                            
     .                 xyz_dexnerdtns(t256+t873-1,t871-1+t258,t869+t260) =      
     .       1            xyz_dexnerdtnl(t216+t873-1,t871-1+t218,t869+t220) +   
     .       2            xyz_picond(xyz_picond.DSC.L1+t873-1,t871-1+           
     .       3            xyz_picond.DSC.L2,t869+xyz_picond.DSC.L3)             
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t871=J3+1,xyz_velsoundbz.DSC.U2-xyz_velsoundbz.DSC.L2+1,2   
     .  !CDIR       NODEP                                                       
     .              do t873=1,xyz_velsoundbz.DSC.U1-xyz_velsoundbz.DSC.L1+1     
     .                 xyz_picond(xyz_picond.DSC.L1+t873-1,t871-1+              
     .       1            xyz_picond.DSC.L2,t869+xyz_picond.DSC.L3) =           
     .       2            xyz_velsoundbz(xyz_velsoundbz.DSC.L1+t873-1,t871-1+   
     .       3            xyz_velsoundbz.DSC.L2,t869+xyz_velsoundbz.DSC.L3)**   
     .       4            2.00000000000000e+000/(cpdry*xyz_densbz(t23+t873-1,   
     .       5            t871-1+t25,t869+t27)*xyz_vptempbz(xyz_vptempbz.DSC.L1+
     .       6            t873-1,t871-1+xyz_vptempbz.DSC.L2,t869+               
     .       7            xyz_vptempbz.DSC.L3)**2.00000000000000e+000)*xyz_mcond
     .       8            (xyz_mcond.DSC.L1+t873-1,t871-1+xyz_mcond.DSC.L2,t869+
     .       9            xyz_mcond.DSC.L3)*(co2latheat/(cpdry*xyz_exnerbz(t45+ 
     .       .            t873-1,t871-1+t47,t869+t49))-xyz_vptempbz(            
     .       1            xyz_vptempbz.DSC.L1+t873-1,t871-1+xyz_vptempbz.DSC.L2,
     .       2            t869+xyz_vptempbz.DSC.L3))                            
     .                 xyz_picond(xyz_picond.DSC.L1+t873-1,t871+                
     .       1            xyz_picond.DSC.L2,t869+xyz_picond.DSC.L3) =           
     .       2            xyz_velsoundbz(xyz_velsoundbz.DSC.L1+t873-1,t871+     
     .       3            xyz_velsoundbz.DSC.L2,t869+xyz_velsoundbz.DSC.L3)**   
     .       4            2.00000000000000e+000/(cpdry*xyz_densbz(t23+t873-1,   
     .       5            t871+t25,t869+t27)*xyz_vptempbz(xyz_vptempbz.DSC.L1+  
     .       6            t873-1,t871+xyz_vptempbz.DSC.L2,t869+                 
     .       7            xyz_vptempbz.DSC.L3)**2.00000000000000e+000)*xyz_mcond
     .       8            (xyz_mcond.DSC.L1+t873-1,t871+xyz_mcond.DSC.L2,t869+  
     .       9            xyz_mcond.DSC.L3)*(co2latheat/(cpdry*xyz_exnerbz(t45+ 
     .       .            t873-1,t871+t47,t869+t49))-xyz_vptempbz(              
     .       1            xyz_vptempbz.DSC.L1+t873-1,t871+xyz_vptempbz.DSC.L2,  
     .       2            t869+xyz_vptempbz.DSC.L3))                            
     .                 xyz_dexnerdtns(t256+t873-1,t871-1+t258,t869+t260) =      
     .       1            xyz_dexnerdtnl(t216+t873-1,t871-1+t218,t869+t220) +   
     .       2            xyz_picond(xyz_picond.DSC.L1+t873-1,t871-1+           
     .       3            xyz_picond.DSC.L2,t869+xyz_picond.DSC.L3)             
     .                 xyz_dexnerdtns(t256+t873-1,t871+t258,t869+t260) =        
     .       1            xyz_dexnerdtnl(t216+t873-1,t871+t218,t869+t220) +     
     .       2            xyz_picond(xyz_picond.DSC.L1+t873-1,t871+             
     .       3            xyz_picond.DSC.L2,t869+xyz_picond.DSC.L3)             
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   290        &  ( xyz_VelSoundBZ ** 2.0d0 )                               &
   291        &     / (CpDry * xyz_DensBZ * (xyz_VPTempBZ ** 2.0d0))        &
   292        &     * xyz_Mcond                                            &
   293        &     * ( CO2LatHeat / (CpDry * xyz_ExnerBZ) - xyz_VPTempBZ )
   294  
   295      xyz_DExnerDtNs = xyz_DExnerDtNl + xyz_PIcond
   296  
   297      call HistoryAutoPut(TimeN, 'PTempCond', xyz_Qcond(1:nx, 1:ny, 1:nz))
   298      call HistoryAutoPut(TimeN, 'ExnerCond', xyz_PIcond(1:nx, 1:ny, 1:nz))
   299      call HistoryAutoPut(TimeN, 'CDensCond', xyz_Mcond(1:nx, 1:ny, 1:nz))
   300  
   301      call SetMargin_xyz(xyz_PTempAs)
   302      call SetMargin_xyz(xyz_CDensAs)
   303      call SetMargin_xyz(xyz_DExnerDtNs)
   304  
   305    end subroutine Cloudphys_marscond_forcing
   306  
   307  end module Cloudphys_MarsCond
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:35:18 2011
FILE NAME: cloudphys_marscond.f90
PROGRAM NAME: cloudphys_marscond
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            !---------------------------------------------------------------------
     2:            !     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
     3:            !---------------------------------------------------------------------
     4:            != Module CloudPhys_marscond
     5:            !
     6:            !   * Developer: KITAMORI Taichi, YAMASHITA Tatsuya, SUGIYAMA Ko-ichiro
     7:            !   * Version: $ 
     8:            !   * Tag Name: $Name: arare5-20111010 $
     9:            !   * Change History: 
    10:            !
    11:            !== Overview 
    12:            !
    13:            !ŷ/ȯ̤׻.
    14:            !
    15:            !== Error Handling
    16:            !
    17:            !== Known Bugs
    18:            !
    19:            !== Note
    20:            !
    21:            ! ȻˤäƱγĹˤĹ. 
    22:            ! ȯ̤¸ߤ̤¿, ȯ̤¸ߤ̤ˤ. 
    23:            ! ̩٤ȯŸ(ŷʬ)׻. 
    24:            ! ˾ʤäȤ˾ȯʤʤäƤޤäƤΤ,
    25:            ! ʬľ.
    26:            
    27:            !
    28:            !== Future Plans
    29:            !
    30:            
    31:            module Cloudphys_MarsCond
    32:            
    33:              use dc_types,   only: DP, STRING
    34:              use dc_iounit,  only: FileOpen
    35:              use dc_message, only: MessageNotify
    36:              use gtool_historyauto, only: HistoryAutoAddVariable, HistoryAutoPut
    37:            
    38:              use mpi_wrapper,only: myrank
    39:              use gridset,  only: imin, imax, jmin, jmax, kmin, kmax, &
    40:                &                 nx, ny, nz
    41:              use basicset, only: xyz_PTempBZ,     & ! ̴ܾ
    42:                &                 xyz_ExnerBZ,     & ! ̵
    43:                &                 xyz_VelSoundBZ,  &! ®
    44:                &                 xyz_VPTempBZ,    &! 
    45:                &                 xyz_DensBZ        ! ̩
    46:              use constants, only:GasRDry,         & ! 
    47:                &                 PressSfc,        & ! ɽ̰
    48:                &                 CpDry              ! 갵Ǯ
    49:              use SetMargin, only:SetMargin_xyz
    50:              use fillnegative, only: FillNegativeDensity
    51:              use namelist_util, only: namelist_filename
    52:              use timeset, only: TimeN, DelTimeShort
    53:              use setmargin,only: SetMargin_xyz, SetMargin_xyzf, SetMargin_pyz, SetMargin_xqz, SetMargin_xyr
    54:            
    55:              implicit none
    56:            
    57:              private
    58:            
    59:              real(DP), save   :: DensIce     = 1.565d3  ! ̩ [kg/m^3]
    60:              real(DP), save   :: NumAerosol  = 0.0d0  ! ο̩ [1/kg]
    61:              real(DP), save   :: RadiAerosol = 0.0d0  ! ο̩ [1/kg]
    62:              real(DP), save   :: Kd          = 0.0d0  ! 絤ǮƳ [W/K m]
    63:              real(DP), save   :: SatRatioCr  = 0.0d0  ! ׳˰ []
    64:              real(DP), save   :: SatRtWetAdia = 0.0d0 ! Ǯ˰ []
    65:              real(DP), save   :: CO2LatHeat  = 0.0d0  ! ñ̼̤ζŷǮ [J/kg]
    66:              real(DP), save   :: AntA        = 27.4d0 
    67:              real(DP), save   :: AntB        = 3103.0d0
    68:              real(DP), save   :: Pi          = 3.1415926535897932385d0 ! ߼Ψ
    69:              real(DP), save   :: CDensCr     = 5.0d-5
    70:            
    71:              public cloudphys_marscond_init
    72:              public cloudphys_marscond_forcing
    73:            
    74:            contains
    75:              
    76:              subroutine cloudphys_marscond_init
    77:                !
    78:                !NAMELIST ʪɤ߹
    79:                !
    80:                
    81:                integer                       :: unit
    82:            
    83:                ! NAMELIST
    84:                NAMELIST /cloudphys_marscond_nml/ DensIce, NumAerosol, RadiAerosol, Kd, & 
    85:                  & SatRatioCr, SatRtWetAdia, CDensCr
    86:                
    87:                call FileOpen(unit, file=namelist_filename, mode='r')
    88:                read(unit, NML=cloudphys_marscond_nml)
    89:                close(unit)    
    90:            
    91:                ! Ǯ. ȸʤ. 
    92:                !   饦ڥδط dp/dT = L p / (R T^2)  
    93:                !   Antoine μ \ln p = A - B/T . 
    94:                CO2LatHeat = AntB * GasRDry
    95:            
    96:                if (myrank == 0) then 
    97:                  call MessageNotify( "M", &
    98:                    & "cloudset_init", "DensIce = %f",  d=(/DensIce/) )
    99:                  call MessageNotify( "M", &
   100:                    & "cloudset_init", "NumAerosol = %f",  d=(/NumAerosol/) )
   101:                  call MessageNotify( "M", &
   102:                    & "cloudset_init", "RadiAerosol = %f",  d=(/RadiAerosol/) )
   103:                  call MessageNotify( "M", &
   104:                    & "cloudset_init", "Kd = %f",  d=(/Kd/) )
   105:                  call MessageNotify( "M", &
   106:                    & "cloudset_init", "SatRatioCr = %f",  d=(/SatRatioCr/) )
   107:                  call MessageNotify( "M", &
   108:                    & "cloudset_init", "SatRtWetAdia = %f",  d=(/SatRtWetAdia/) )
   109:                end if
   110:            
   111:                call HistoryAutoAddVariable(  &
   112:                  & varname='PTempCond',&
   113:                  & dims=(/'x','y','z','t'/),     &
   114:                  & longname='Latent heat term of potential temperature', &
   115:                  & units='K.s-1',    &
   116:                  & xtype='float')
   117:            
   118:                call HistoryAutoAddVariable(  &
   119:                  & varname='ExnerCond',&
   120:                  & dims=(/'x','y','z','t'/),     &
   121:                  & longname='Latent heat term of exner function', &
   122:                  & units='s-1',    &
   123:                  & xtype='float')
   124:            
   125:                call HistoryAutoAddVariable(  &
   126:                  & varname='CDensCond',&
   127:                  & dims=(/'x','y','z','t'/),     &
   128:                  & longname='Latent heat term of cloud density', &
   129:                  & units='K.m-3.s-1',    &
   130:                  & xtype='float')
   131:            
   132:              end subroutine cloudphys_marscond_init
   133:              
   134:            
   135:            !!!----------------------------------------------------
   136:              subroutine cloudphys_marscond_forcing(  &
   137:                &  xyz_PTempNs,         &  !(in) 
   138:                &  xyz_ExnerNs,         &  !(in) ʡؿ
   139:                &  xyz_CDensNs,         &  !(in) 
   140:                &  xyz_DPTempDtNl,      &  !(in)    
   141:                &  xyz_DExnerDtNl,      &  !(in)    
   142:                &  xyz_DCDensDtNl,      &  !(in)    
   143:                &  xyz_PTempAs,         &  !(out) 
   144:                &  xyz_CDensAs,         &  !(out) ̩
   145:                &  xyz_DExnerDtNs       &  !(out) 
   146:                & )
   147:                       
   148:                ! ۤηػ
   149:                implicit none
   150:                
   151:                ! Input
   152:                real(DP), intent(in)   :: xyz_PTempNs(imin:imax, jmin:jmax, kmin:kmax) 
   153:                                                    ! ̵ [1]
   154:                real(DP), intent(in)   :: xyz_ExnerNs(imin:imax, jmin:jmax, kmin:kmax) 
   155:                                                    ! 
   156:                real(DP), intent(in)   :: xyz_CDensNs(imin:imax, jmin:jmax, kmin:kmax) 
   157:                                                    ! 
   158:                real(DP), intent(in)   :: xyz_DPTempDtNl(imin:imax, jmin:jmax, kmin:kmax) 
   159:            
   160:                real(DP), intent(in)   :: xyz_DExnerDtNl(imin:imax, jmin:jmax, kmin:kmax) 
   161:            
   162:                real(DP), intent(in)   :: xyz_DCDensDtNl(imin:imax, jmin:jmax, kmin:kmax) 
   163:            
   164:                real(DP), intent(out)  :: xyz_PTempAs(imin:imax, jmin:jmax, kmin:kmax) 
   165:                                                    !  [K]
   166:                real(DP), intent(out)  :: xyz_CDensAs(imin:imax, jmin:jmax, kmin:kmax)   
   167:                                                    ! ̩   [kg/m^3]
   168:                real(DP), intent(out)  :: xyz_DExnerDtNs(imin:imax, jmin:jmax, kmin:kmax) 
   169:                                                    ! ŷǮˤ벹ѲΨ [K/s]
   170:              
   171:                ! Work
   172:                real(DP)               :: xyz_RadiCloud(imin:imax, jmin:jmax, kmin:kmax)
   173:                                                    ! γȾ [m]
   174:                real(DP)               :: xyz_SatRatio(imin:imax, jmin:jmax, kmin:kmax)
   175:                real(DP)               :: xyz_Rh(imin:imax, jmin:jmax, kmin:kmax)
   176:                real(DP)               :: xyz_TempAll(imin:imax, jmin:jmax, kmin:kmax)
   177:                real(DP)               :: xyz_Mcond(imin:imax, jmin:jmax, kmin:kmax)
   178:                real(DP)               :: xyz_Qcond(imin:imax, jmin:jmax, kmin:kmax)
   179:                real(DP)               :: xyz_McondTmp(imin:imax, jmin:jmax, kmin:kmax)
   180:                real(DP)               :: xyz_PIcond(imin:imax, jmin:jmax, kmin:kmax)
   181:                real(DP)               :: xyz_Zero(imin:imax, jmin:jmax, kmin:kmax)
   182:                real(DP)               :: xyz_PTempTmp(imin:imax, jmin:jmax, kmin:kmax)
   183:                real(DP)               :: xyz_CDensTmp(imin:imax, jmin:jmax, kmin:kmax)
   184:                logical                :: xyz_Mask(imin:imax, jmin:jmax, kmin:kmax)
   185:                integer                :: i,j,k        ! 롼ѿ
   186:             
   187:            
   188:            
   189:                ! ȯŸ
   190:                !
   191: **V---->       xyz_PTempTmp = xyz_PTempNs + DelTimeShort * xyz_DPTempDtNl
   192: **V----        xyz_CDensTmp = xyz_CDensNs + DelTimeShort * xyz_DCDensDtNl
   193:            
   194:                ! Set Margin
   195:                !
   196:                call SetMargin_xyz(xyz_PTempTmp)
   197:                call SetMargin_xyz(xyz_CDensTmp)
   198:            
   199:                ! ήˤʤäʬ
   200:                ! 
   201:                call FillNegativeDensity(xyz_CDensTmp)
   202:            
   203:                ! Set Margin
   204:                !
   205:                call SetMargin_xyz(xyz_CDensTmp)
   206:            
   207:                ! tendency  Ns ͤǷ׻
   208:                !
   209: **V---->       xyz_TempAll = (xyz_ExnerBZ + xyz_ExnerNs) * (xyz_PTempBZ + xyz_PTempNs)
   210: |||            xyz_Mask = .false. 
   211: |||            xyz_Zero = 0.0d0
   212: |||           
   213: |||            ! Ǯ͢˴ؤ뷸
   214: |||            ! 
   215: |||            xyz_Rh = (CO2LatHeat**2.0d0) / (Kd * GasRDry * (xyz_TempAll**2.0d0))
   216: |||        
   217: |||            ! ˰ (1.36) . 
   218: |||            !
   219: |||            xyz_SatRatio =  &
   220: |||              &  PressSfc * (xyz_ExnerBZ + xyz_ExnerNs)**(CpDry / GasRDry) &
   221: |||              &  / exp( AntA - AntB / xyz_TempAll )  
   222: |||        
   223: |||            ! γȾ. 
   224: |||            !
   225: **V----        xyz_RadiCloud =   &
   226:                  & (  &
   227:                  &     RadiAerosol**3.0d0  &
   228:                  &   + 3.0d0 * xyz_CDensNs / (4.0d0 * Pi * DensIce * xyz_DensBZ * NumAerosol) & 
   229:                  &  ) ** (1.0d0 / 3.0d0)
   230:            
   231:                ! ŷ̤η׻
   232:                !
   233: +------>       do k = kmin, kmax
   234: |+----->         do j = jmin, jmax
   235: ||V---->           do i = imin, imax
   236: |||                  if (xyz_SatRatio(i,j,k) - SatRatioCr > epsilon(0.0d0)) then
   237: |||                    ! ˰椬᤿׳˰礭
   238: |||                    ! CO2 ˰μϵ絤Ѥ˰μʤΤʤΤǧɬפ. 
   239: |||                    !
   240: |||                    xyz_Mask(i,j,k) = .true. 
   241: |||                    
   242: |||                  else if (xyz_CDensNs(i,j,k) > CDensCr ) then
   243: |||                    ! ׳˰ĶƤʤ, ̩٤ͰʾǤ
   244: |||                    ! ˰椬 1 ʾΤȤ˶ŷ, 1 ʲΤȤ˾ȯ. 
   245: |||                    !
   246: |||                    xyz_Mask(i,j,k) = .true. 
   247: |||                    
   248: |||                  else if (xyz_CDensNs(i,j,k) /= 0.0d0 .and. xyz_SatRatio(i,j,k) < 1.0d0 ) then
   249: |||                    ! ̩٤̤, ˰ 1.0 ̤Ǥ˾ȯ. 
   250: |||                    !
   251: |||                    xyz_Mask(i,j,k) = .true. 
   252: |||        
   253: |||                  end if
   254: ||V----            end do
   255: |+-----          end do
   256: +------        end do
   257:            
   258:                ! ŷ̤βͤ׻. 
   259:                !
   260: **V---->       xyz_McondTmp =                                                &
   261: |||              & max( - xyz_CDensTmp / DelTimeShort,                       &
   262: |||              &      4.0d0 * Pi * xyz_RadiCloud * xyz_DensBZ * NumAerosol &
   263: |||              &        / xyz_Rh * (xyz_SatRatio - 1.0d0)                  &
   264: |||              &   )
   265: |||        
   266: |||            ! ŷ̤׻. Mask  .false. Ǥˤϥ
   267: |||            !
   268: |||            xyz_Mcond = merge(xyz_McondTmp, xyz_Zero, xyz_Mask)
   269: |||        
   270: |||            ! ̩٤η׻ 
   271: |||            !
   272: **V----        xyz_CDensAs = xyz_CDensTmp + DelTimeShort * xyz_Mcond
   273:            
   274:                ! Set Margin
   275:                !
   276:                call SetMargin_xyz(xyz_CDensAs)
   277:            
   278:                ! Ѳη׻
   279:                ! 
   280: **V---->       xyz_Qcond = CO2LatHeat * xyz_Mcond / (CpDry * xyz_DensBZ * xyz_ExnerBZ)
   281: **V----        xyz_PTempAs = xyz_PTempTmp + DelTimeShort * xyz_QCond
   282:            
   283:                ! Set Margin
   284:                !
   285:                call SetMargin_xyz(xyz_PTempAs)
   286:                
   287:                ! ʡؿλʬ
   288:                ! 
   289: **V---->       xyz_PIcond =                                                   &
   290: |||              &  ( xyz_VelSoundBZ ** 2.0d0 )                               &
   291: |||              &     / (CpDry * xyz_DensBZ * (xyz_VPTempBZ ** 2.0d0))        &
   292: |||              &     * xyz_Mcond                                            &
   293: |||              &     * ( CO2LatHeat / (CpDry * xyz_ExnerBZ) - xyz_VPTempBZ ) 
   294: |||        
   295: **V----        xyz_DExnerDtNs = xyz_DExnerDtNl + xyz_PIcond
   296:                
   297:                call HistoryAutoPut(TimeN, 'PTempCond', xyz_Qcond(1:nx, 1:ny, 1:nz))
   298:                call HistoryAutoPut(TimeN, 'ExnerCond', xyz_PIcond(1:nx, 1:ny, 1:nz))
   299:                call HistoryAutoPut(TimeN, 'CDensCond', xyz_Mcond(1:nx, 1:ny, 1:nz))
   300:            
   301:                call SetMargin_xyz(xyz_PTempAs)
   302:                call SetMargin_xyz(xyz_CDensAs)
   303:                call SetMargin_xyz(xyz_DExnerDtNs)
   304:            
   305:              end subroutine Cloudphys_marscond_forcing
   306:              
   307:            end module Cloudphys_MarsCond
